﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;
using Infragistics.Win.UltraWinTabControl;

namespace UltraTabControlTabsReorder
{
    public partial class Form1 : Form
    {
        private DataTable dt;
        public Form1()
        {
            InitializeComponent();
            dt = new DataTable();
            dt.Columns.Add("Index", typeof(int));
            dt.Columns.Add("VisibleIndex", typeof(int));
            dt.Columns.Add("RowCount", typeof(int));
            dt.Columns.Add("TabItem", typeof(UltraTab));
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            foreach (var item in ultraTabControl1.Tabs)
            {
                foreach (Control ctr in item.TabPage.Controls)
                {
                    if (ctr.GetType() == typeof(UltraGrid))
                    {
                        dt.Rows.Add(item.Index, item.VisibleIndex, ((UltraGrid)ctr).Rows.Count, item);
                    }
                }
            }

            DataView dataView = new DataView(dt);
            dataView.Sort = " RowCount DESC";

            int k=0;
            foreach (DataRowView view in dataView)
            {
                ((UltraTab)view.Row.Field<UltraTab>("TabItem")).VisibleIndex = k;
                k++;
            }
        }
    }
}
